#!/bin/bash

exec 0<&-
exec 0<> /dev/null

exec 1<&-
exec 1<> /dev/null

exec 2<&-
exec 2<> /dev/null

panic()
{
    echo "$*" >&2
    exit 1
}

find_display()
{
    local n
    for n in $(seq 200 512); do
        if ! [ -f "/tmp/.X${n}-lock" ]; then
            echo ":${n}.0"
            break
        fi
    done
}

[ ! -x /usr/bin/Xephyr ] && panic "No Xephyr found"

app="${1}"
[ -z "${app}" ] && panic "No application name"

# 1) подобрать назанятый номер дисплея для Xephyr, например, начиная с :200
display=:`fly-wmfunc FLYWM_GET_FREE_DISPLAY 200`
#display=$(find_display)
[ -z "${display}" ] && panic "Can't find display"

# 2) сформировать доп. аргументы

#FIXME: no ru layout if so:
#args="-keybd ephyr,,,xkbmodel=evdev,xkblayout=us,ru,xkbrules=evdev ${args}"

title="${app} в изолированной среде (ctrl+g для захвата мыши и клавиатуры)"

rcfile="/usr/share/fly-wm/fly-wmrc.mini"

onlyXclient=`which "${1}"`

# экранируем аргументы командной строки
C=()
for i in "$@"; do
    C+=("$i")
done

# 3) запустить fly-wm и приложение в Xephyr

if [ "${1}" == "fly-fm" ]; then
    if [ -z "$ROOT_DISPLAY" ]; then
        export ROOT_DISPLAY=$DISPLAY
    fi
    if [ -z "$DBUS_SESSION_BUS_ADDRESS" ]; then
        dbus_launch="/usr/bin/dbus-launch --exit-with-session"
    fi
    xinit ${dbus_launch} /usr/bin/fly-wm --display "${display}" --rcfile "${rcfile}" --execOnly "${C[@]}" &> /dev/null -- \
    /usr/bin/Xephyr "${display}" -autosize -resizeable -title "${title}" ${args}
else
    xinit /usr/bin/fly-wm --display "${display}" --rcfile "${rcfile}" --execOnly "${C[@]}" &> /dev/null -- \
    /usr/bin/Xephyr "${display}" -autosize -resizeable -title "${title}" -onlyclienttree "${onlyXclient}" ${args}
fi
